program main
    use diff
    implicit none
    real(mp) x, y, h
    real(mp), allocatable :: x1(:)
    integer(mp)  n, i 

    allocate(x1(1:n + 1))

    open(1, file = "input") 
    open(2, file = "result") 

    read(1,*) x, y, n, h 
    write(2,*) "Начальная точка = ","(",x,",", y,")"
    write(2,*) "n =", n
    write(2,*) "Шаг =", h

    write(2,*) "#############################################################################################"
    x1(1) = x
    do i = 1, n + 4 
       x1(i+1) = x1(i) + h
    enddo


    write(2,'(2x,"Метод Эйлера:") ') 

    write(2,*) "y(i)", Euler(f1, n, h, x, y)
    write(2,*) "x(i)", (x1(i), i = 1, n + 1)
    write(2,*) "#################################################################################################################"

    write(2,'(2x,"Метод Рунге - Кутты:") ') 

    write(2,*) "y(i)", Runge_kutta(f1, n, h, x, y)
    write(2,*) "x(i)", (x1(i), i = 1, n + 1)
    write(2,*) "#################################################################################################################"

    write(2,'(2x,"Метод Адамса:") ') 

    write(2,*) "y(i)", Adams(f1, n, h, x, y)
    write(2,*) "x(i)", (x1(i), i = 1, n + 4)
    write(2,*) "#################################################################################################################"

    close(1)
    close(2)




end program main